{
	Decimate.dsp		
Real time Direct Form Finite Impulse Filter, N taps, decimates by M for a
decrease of 1/M times the input sample rate.

	Input: adc.
	Output: dac.
}

.module/ram/abs=0	decimate;
.const 			N=300;
.const			M=4;			{decimate by factor of M}
.var/pm/ram/circ	coef[N];
.var/dm/ram/circ	data[N];
.var/dm/ram		counter;
.port			adc;
.port			dac;
.init			coef:<coef.dat>;
		rti;				{interrupt 0}
		rti;				{interrupt 1}
		rti;				{interrupt 2}
		jump sample;			{interrupt 3= input sample rate}

initialize:	imask=b#0000;			{disable all interrupts}
		icntl=b#01111;			{edge sensitive interrupts}
		si=M;				{set to decimation counter to M}
		dm(counter)= si;		{for first input data sample}
		i4=^coef;			{setup a circular buffer in PM}
		l4=%coef;			
		m4=1;				{modifier for coef is 1}
		i0=^data;			{setup a circular buffer in DM}
		l0=%data;			
		m0=1;				{modifier for data is 1}
		imask=b#1000;			{enable interrupt 3}
wait_interrupt:	jump wait_interrupt;		{infinite wait loop}

{}
{___________________Decimator, code occurs at the sample rate__________________}
sample:		ay0=dm(adc);
		dm(i0,m0)=ay0;			{update delay line with newest}
		ay0=dm(counter);		
		ar=ay0-1;			{decrement and update counter}
		dm(counter)=ar;
		if ne rti;			{test and return if not M times}

{__________________code below occurs at 1/M times the sample rate______________}
do_fir:		ar=M;				{reset the counter to M}
		dm(counter)=ar;
		cntr=N - 1;
		mr=0, mx0=dm(i0,m0), my0=pm(i4,m4);
		do taploop until ce;    	{N-1 taps of FIR}
taploop:	   mr=mr+mx0*my0(ss), mx0=dm(i0,m0), my0=pm(i4,m4);
		mr=mr+mx0*my0(rnd);		{last tap with round}
		if mv sat mr;			{saturate result if overflow}
		dm(dac)=mr1;			{output data sample}
		rti;				
.endmod;
