.MODULE diriir_sub;

{
        Direct Form IIR Filter Subroutine

        Calling Parameters
                MR1 = Input sample ( x[n] )
                MR0 = 0
                I0 --> Delay line buffer current location ( x[n-1] )
                L0 = Filter length
                I5 --> Feedback coefficients (a's)
                L5 = Filter length - 1
                I6 --> Feedforward coefficients (b's)
                L6 = Filter length
                M0 = 0
                M1,M4 = 1
		M2 = 2
                CNTR = Filter length - 2
                AX0 = Filter length - 1

        Return Values
                MR1 = output sample ( y[n] )
                I0 --> delay line current location ( x[n-1] )
                I5 --> feedback coefficients
                I6 --> feedforward coefficients

        Altered Registers
                MX0,MY0,MR

        Computation Time
                (N - 2) + (N - 1) + 10 + 4 cycles  (N = M = Filter order)

        All coefficients and data values are assumed to be in 1.15 format.
}

.ENTRY  diriir;

diriir: MX0=DM(I0,M1), MY0=PM(I5,M4);
        DO poleloop UNTIL CE;
poleloop:               MR=MR+MX0*MY0(SS), MX0=DM(I0,M1), MY0=PM(I5,M4);
        MR=MR+MX0*MY0(RND);
        CNTR=AX0;
        DM(I0,M0)=MR1;
        MR=0, MX0=DM(I0,M1), MY0=PM(I6,M4);
        DO zeroloop UNTIL CE;
zeroloop:               MR=MR+MX0*MY0(SS), MX0=DM(I0,M1), MY0=PM(I6,M4);
        MR=MR+MX0*MY0(RND);
	MODIFY (I0,M2);
        RTS;
.ENDMOD;
