.MODULE drsg_sub;

{
        Double-Precision SG Coefficient Adaptation Subroutine

        Calling Parameters
                MX0 =   Error
                MY1 =   Beta
                I2 -->  Oldest input data value in delay line
                L2 =    Filter length
                I6 -->  Beginning of filter coefficient table
                L6 =    2 * Filter length
                M1,M5 = 1
                M3,M7 = -1
                CNTR =  Filter length

        Return Values
                Coefficients updated
                I2 -->  Oldest input data value in delay line
                I6 -->  Beginning of filter coefficient table

        Altered Registers
                AY0,AR,MX0,MF,MR

        Computation Time
                (4 * Filter length) + 5 + 4 cycles

        All coefficients are assumed to be in 1.31 format.
        All data are assumed to be in 1.15 format.

}

.ENTRY  drsg;

drsg:   MF=MX0*MY1(RND), MX0=DM(I2,M1);      {MF=Be, MX0=y}
        MR=MX0*MF(SS);                       {MR=Bey}
        DO adaptd UNTIL CE;
          MX0=DM(I2,M1), AY0=PM(I6,M5);      {MX0=y, AY0=cls}
          AR=MR0+AY0, AY0=PM(I6,M7);         {AR=beyls+clsw,AY0=cms}
          AR=MR1+AY0+C, PM(I6,M5)=AR;        {AR=beyms+cmsw,cms'=AR}
adaptd:   MR=MX0*MF(SS), PM(I6,M5)=AR;       {MR=bey, cms'=AR}
        MODIFY (I2,M3);                      {fix for extra DM read}
        RTS;
.ENDMOD;
