.MODULE two_dimensional_FIR_filter;

{                Q-1  R-1
        G(x,y) = SUM  SUM  [ H(i,j) * F(x-i,y-j) ]
                 i=0  j=0
 
        Calling Parameters
                I0 --> F, SxT Input Matrix stored by rows           L0 = 0
                I1 --> G, (S-Q)x(T-R) Output Matrix stored by rows  L1 = 0
                I4 --> H, QxR Coefficient Matrix stored by rows     L4 = Q*R
                M0,M4 = 1
                M1 = T-R+1              
                M2 = -(Q*T+1)          AX1 = Q
                M3 = R-1               AY0 = R-2
                CNTR = S-Q             AX0 = T-R

        Return Values
                G(x,y) filled [Output Matrix]

        Altered Registers
                MX0,MY0,MR,I0,I1,I4,L4

        Computation Time 
                (((R-2+4)*Q+5)*(T-R)+3)*(S-Q)+3+4 cycles
                -- or -- (see text)
                (((R-2+4)*Q+5)*T+3)*S+3+4 cycles
}

.ENTRY  tdfir;

tdfir:  MY0=PM(I4,M4);                       {Get first coefficient}
        DO in_row UNTIL CE;                  {Loop through output rows}
           CNTR=AX0;
           DO in_col UNTIL CE;               {Loop through output columns}
              CNTR=AX1;
              MR=0, MX0=DM(I0,M0);           {Clear MR, get input data}
              DO row_loop UNTIL CE;          {Loop through coefficient rows}
                 CNTR=AY0;
                 DO col_loop UNTIL CE;       {Loop through coefficient cols}
col_loop:           MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
                 MR=MR+MX0*MY0 (SS), MX0=DM(I0,M1), MY0=PM(I4,M4);
                 {Move pointer to next convolution window row}
row_loop:        MR=MR+MX0*MY0 (SS), MX0=DM(I0,M0), MY0=PM(I4,M4);
                 {Read values for next loop}
              DM(I1,M0)=MR1;                 {Save output points}
in_col:       MODIFY(I0,M2);                 {Get next conv. start same row}
in_row:    MODIFY(I0,M3);                    {Point to next input row}
        RTS;
.ENDMOD;
