.MODULE all_zero_lattice_filter;

{
        All Zero Lattice

        Calling Parameters
                CNTR = Length of Output Buffer
                I0 --> Input Buffer                     L1 = 0
                I2 --> Output Buffer                    L2 = 0
                I3 --> Delay Line Buffer (circular)     L3 = Filter Order
                I4 --> Coefficient Buffer (circular)    L4 = Filter Order
                M0 = 1
                M2 = 0
                M3 = 1
                M4 = 1
                SE = Appropriate Scale Factor
                MF = Formatted 1

        Return Values
                Output Buffer Filled

        Altered Registers
                MX0,MX1,MY0,MF,MR,SR,I2,I3,I4

        Computation Time
                (8 * Filter Order + 4) * Output Buffer Length + 3 + 1 cycles
}

.ENTRY z_latt;

z_latt: SR1=0;                                       {Clear SR1 for first pass}
        DO out_loop UNTIL CE;                        {Loop output length}
                CNTR=L3;
                MX0=DM(I0,M0);                       {Get excitation signal}
                DO latt_loop UNTIL CE;               {Loop through filter}
                        MR=MX0*MF (SS), MX1=DM(I3,M2), MY0=PM(I4,M4); {Get U,K}
                        MR=MR+MX1*MY0 (SS), DM(I3,M3)=SR1; {Compute Yz store U}
                        SR=ASHIFT MR1 (HI);          {Reformat Yz}
                        SR=SR OR LSHIFT MR0 (LO);
                        MR=MX1*MF (SS);              {Format Uz-1}
                        MX0=SR1, MR=MR+MX0*MY0 (SS); {Compute Uz and Hold Yz}
                        SR=ASHIFT MR1 (HI);          {Reformat Uz}
latt_loop:              SR=SR OR LSHIFT MR0 (LO);
out_loop:      DM(I2,M0)=MX0;                        {Save output}
        RTS;
.ENDMOD;
